#include "windows.h"
#include "resource.h"
#include "SoundClasses\SoundClasses.h"

// Variabili globali ------------------------------------------------
HWND		hWnd;
HINSTANCE	hInst;
Listener	listener;
SimpleSound	Sound;
//-------------------------------------------------------------------

bool InitApplication(HINSTANCE hInstance, int nCmdShow);

// Entry point ------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{ 		
	MSG msg;	
	
	if (!InitApplication(hInstance, nCmdShow)) return 0;	

	listener.Init(hWnd, 0, 2, 44100, 16);
	listener.SetSpeakerMode(DSSPEAKER_STEREO);
	Sound.LoadWave("sfx\\laser.wav");	

	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);		
	}

	return msg.wParam;
}
// WndProc-----------------------------------------------------------
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;	

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			
			switch (wmId)
			{	case IDM_PLAYLASER:
					Sound.Play();
					break;
				case IDM_PLAYLASERLOOP:
					Sound.Play(true);
					break;
				case IDM_STOP:
					Sound.Stop();
					break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}
// InitApplication --------------------------------------------------
bool InitApplication(HINSTANCE hInstance, int nCmdShow)
{
	hInst = hInstance;
	
	WNDCLASSEX wcex;
	wcex.cbSize = sizeof(WNDCLASSEX); 
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_DSOUNDTEST);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_DSOUNDTEST;
	wcex.lpszClassName	= "DSOUND Window";
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	if (!RegisterClassEx(&wcex)) return false;

	hWnd =  CreateWindow("DSOUND Window", 
						"DSound Test", 
						WS_OVERLAPPEDWINDOW,
						CW_USEDEFAULT, 0, 
						CW_USEDEFAULT, 0, 
						NULL, 
						NULL, 
						hInstance, 
						NULL);

   if (!hWnd)	return false;

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return true;
}
//-------------------------------------------------------------------