#ifndef	_SOUNDCLASSES_H
#define	_SOUNDCLASSES_H

#include "DSound.h"
#include "SoundStructs.h"

#define MAXDEVICES 10
// Listener ---------------------------------------------------------
class Listener	{
public:
	Listener();
	~Listener();

	bool Init			(HWND hWindow, unsigned int Device = 0, int nChannels = 0, int samplesPerSec = 0, int bitsPerSample = 0);
	bool SetSpeakerMode	(unsigned int mode);	
	static LPDIRECTSOUND GetDSObject()	{ return mlpDS;	};
	
protected:		
	static bool CALLBACK EnumDevicesProc(LPGUID lpGUID, char *lpszDesc, char *lpszDrvName, void * lpContext);
	
	bool EnumDevices		();
	void DeallocDevicesList	();
	bool CreatePrimaryBuffer(int nChannels, int samplesPerSec, int bitsPerSample, unsigned int BufferProperties = 0);	


	static LPDIRECTSOUND		mlpDS;
	static LPDIRECTSOUNDBUFFER	mPrimary;
	static tAudioDeviceInfo		mDevices[MAXDEVICES];
	static unsigned int			mDevicesNum;
};
//-------------------------------------------------------------------
class SimpleSound {
public :
	SimpleSound		();
	SimpleSound		(char *FileName);
	SimpleSound		(SimpleSound &sound);
	~SimpleSound	();

	void Play		(bool Looping = false);
	void Stop		();
	
	unsigned long GetFrequency		();
	bool		  SetFrequency		(unsigned long Frequency);
	
	long		  GetVolume			();
	bool		  SetVolume			(long Volume);

	unsigned long GetCurrentPosition();
	bool		  SetCurrentPosition(unsigned long Position);
	
	bool LoadWave	(char *FileName);

protected :
	bool AllocBuffer(int nChannels, int samplesPerSec, int bitsPerSample, 
					 unsigned int size, unsigned int BufferProperties = 0);

	LPDIRECTSOUNDBUFFER    mBuffer;	
};
//-------------------------------------------------------------------
#endif //_SOUNDCLASSES_H